/*
 * Userspace lzma_inflate implementation
 *
 * This is derived from the 2.6.8.1 kernel patch available at
 * http://www.efixo.com/neufbox4/freesoftware/archives/kernel.patch,
 * Which doesn't bear any copyright notice.
 *
 * Changes to this file are 
 * Copyright (c) 2008 Simon Vallet <svallet@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * IInOutStreams.c
 */
#include "IInOutStreams.h"

static void *lib_memcpy(void *dest,const void *src,size_t cnt)
{
  unsigned char *d;
  const unsigned char *s;
  
  d = (unsigned char *) dest;
  s = (const unsigned char *) src;
  
  while (cnt) {
    *d++ = *s++;
    cnt--;
  }
  
  return dest;
}

HRESULT InStreamRead(void *aData, UINT32 aSize, UINT32* aProcessedSize)
{
  if (aSize > in_stream.remainingBytes) {
    aSize = in_stream.remainingBytes;
  }

  *aProcessedSize = aSize;
  lib_memcpy(aData, in_stream.data, aSize);
  in_stream.remainingBytes -= aSize;
  in_stream.data += aSize;
  
  return S_OK;
}

