/*
 * User-space lzma_inflate implementation
 *
 * This is derived from the 2.6.8.1 kernel patch available at
 * http://www.efixo.com/neufbox4/freesoftware/archives/kernel.patch,
 * Which doesn't bear any copyright notice.
 *
 * Changes to this file are 
 * Copyright (c) 2008 Simon Vallet <svallet@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * BitTreeCoder.h
 */
#ifndef __RCDEFS_H
#define __RCDEFS_H

#include "AriBitCoder.h"

#define RC_GETBIT2(aNumMoveBits, aProb, aModelIndex, Action0, Action1)                        \
{                                                                 \
  UINT32 aNewBound = (aRange >> kNumBitModelTotalBits) * aProb;   \
  if (aCode < aNewBound) {                                        \
     Action0;                                                     \
     aRange = aNewBound;                                          \
     aProb += (kBitModelTotal - aProb) >> aNumMoveBits;           \
     aModelIndex <<= 1;                                           \
  } else {                                                        \
     Action1;                                                     \
     aRange -= aNewBound;                                         \
     aCode -= aNewBound;                                          \
     aProb -= (aProb) >> aNumMoveBits;                            \
     aModelIndex = (aModelIndex << 1) + 1;                        \
  }                                                               \
                                                                  \
  if (aRange < kTopValue) {                                       \
     aCode = (aCode << 8) | InStreamReadByte(in_stream);          \
     aRange <<= 8;                                                \
  }                                                               \
}

#define RC_GETBIT(aNumMoveBits, aProb, aModelIndex) RC_GETBIT2(aNumMoveBits, aProb, aModelIndex, ; , ;)

#endif
