/*
 * User-space lzma_inflate implementation
 *
 * This is derived from the 2.6.8.1 kernel patch available at
 * http://www.efixo.com/neufbox4/freesoftware/archives/kernel.patch,
 * Which doesn't bear any copyright notice.
 *
 * Changes to this file are 
 * Copyright (c) 2008 Simon Vallet <svallet@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * WindowOut.h
 */
#ifndef __STREAM_WINDOWOUT_H
#define __STREAM_WINDOWOUT_H

#include "IInOutStreams.h"

typedef struct WindowOut
{
  BYTE  *Buffer;
  UINT32 Pos;
} WindowOut;

extern WindowOut out_window;

#define OutWindowInit() \
{ \
  out_window.Buffer = (BYTE *) out_stream.data; \
  out_window.Pos = 0; \
}

#define OutWindowFlush() \
{ \
  OutStreamSizeSet( out_window.Pos ); \
} 

INLINE void OutWindowCopyBackBlock(UINT32 aDistance, UINT32 aLen)
{
  BYTE   *p = out_window.Buffer + out_window.Pos;
  UINT32  i;
  aDistance++;
  
  for (i = 0; i < aLen; i++) { p[i] = p[i - aDistance]; }

  out_window.Pos += aLen;
}

#define OutWindowPutOneByte(aByte) \
{ \
  out_window.Buffer[out_window.Pos++] = aByte; \
} 

#define OutWindowGetOneByte(anIndex) (out_window.Buffer[out_window.Pos + anIndex])

#endif
